Index: boot/arch/mips32/loader/Makefile
===================================================================
--- boot/arch/mips32/loader/Makefile	(revision 5f4cfb1e7a458e3e1ce5197e0a3163a542b56b55)
+++ boot/arch/mips32/loader/Makefile	(revision 13125d316cadbe5c47c47ef30447ada47c3c3615)
@@ -83,4 +83,5 @@
 	$(USPACEDIR)/srv/kbd/kbd \
 	$(USPACEDIR)/srv/console/console \
+	$(USPACEDIR)/srv/devmap/devmap \
 	$(USPACEDIR)/app/init/init \
 	$(USPACEDIR)/app/tetris/tetris \
Index: uspace/Makefile
===================================================================
--- uspace/Makefile	(revision 5f4cfb1e7a458e3e1ce5197e0a3163a542b56b55)
+++ uspace/Makefile	(revision 13125d316cadbe5c47c47ef30447ada47c3c3615)
@@ -43,4 +43,5 @@
 	srv/fs/fat \
 	srv/vfs \
+	srv/devmap \
 	app/tetris \
 	app/tester \
Index: uspace/lib/libc/include/ipc/services.h
===================================================================
--- uspace/lib/libc/include/ipc/services.h	(revision 5f4cfb1e7a458e3e1ce5197e0a3163a542b56b55)
+++ uspace/lib/libc/include/ipc/services.h	(revision 13125d316cadbe5c47c47ef30447ada47c3c3615)
@@ -44,5 +44,6 @@
 	SERVICE_CONSOLE,
 	SERVICE_RD,
-	SERVICE_VFS
+	SERVICE_VFS,
+	SERVICE_DEVMAP
 } services_t;
 
Index: uspace/srv/devmap/Makefile
===================================================================
--- uspace/srv/devmap/Makefile	(revision 13125d316cadbe5c47c47ef30447ada47c3c3615)
+++ uspace/srv/devmap/Makefile	(revision 13125d316cadbe5c47c47ef30447ada47c3c3615)
@@ -0,0 +1,76 @@
+#
+# Copyright (c) 2005 Martin Decky
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+## Setup toolchain
+#
+
+LIBC_PREFIX = ../../lib/libc
+SOFTINT_PREFIX = ../../lib/softint
+include $(LIBC_PREFIX)/Makefile.toolchain
+
+CFLAGS += -I../libipc/include
+
+LIBS =  $(LIBC_PREFIX)/libc.a
+
+## Sources
+#
+
+OUTPUT = devmap
+SOURCES = \
+	devmap.c 
+
+CFLAGS += -D$(ARCH)
+
+OBJECTS := $(addsuffix .o,$(basename $(SOURCES)))
+
+.PHONY: all clean depend disasm
+
+all: $(OUTPUT) disasm
+
+-include Makefile.depend
+
+clean:
+	-rm -f $(OUTPUT) $(OUTPUT).map $(OUTPUT).disasm Makefile.depend
+
+depend:
+	$(CC) $(DEFS) $(CFLAGS) -M $(SOURCES) > Makefile.depend
+
+$(OUTPUT): $(OBJECTS) $(LIBS)
+	$(LD) -T $(LIBC_PREFIX)/arch/$(ARCH)/_link.ld $(OBJECTS) $(LIBS) $(LFLAGS) -o $@ -Map $(OUTPUT).map
+
+disasm:
+	$(OBJDUMP) -d $(OUTPUT) >$(OUTPUT).disasm
+
+%.o: %.S
+	$(CC) $(DEFS) $(AFLAGS) $(CFLAGS) -D__ASM__ -c $< -o $@
+
+%.o: %.s
+	$(AS) $(AFLAGS) $< -o $@
+
+%.o: %.c
+	$(CC) $(DEFS) $(CFLAGS) -c $< -o $@
Index: uspace/srv/devmap/devmap.c
===================================================================
--- uspace/srv/devmap/devmap.c	(revision 13125d316cadbe5c47c47ef30447ada47c3c3615)
+++ uspace/srv/devmap/devmap.c	(revision 13125d316cadbe5c47c47ef30447ada47c3c3615)
@@ -0,0 +1,123 @@
+/*
+ * Copyright (c) 2007 Josef Cejka
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/**
+ * @defgroup devmap Device mapper.
+ * @brief	HelenOS device mapper.
+ * @{
+ */ 
+
+/** @file
+ */
+
+#include <ipc/ipc.h>
+#include <ipc/services.h>
+#include <ipc/ns.h>
+#include <async.h>
+#include <stdio.h>
+#include <errno.h>
+
+#include "devmap.h"
+
+/** Initialize device mapper. 
+ *
+ *
+ */
+static int devmap_init()
+{
+	/* */
+
+	return 0;
+}
+
+
+/** Function for handling connections to devmap 
+ *
+ */
+static void
+devmap_client_connection(ipc_callid_t iid, ipc_call_t *icall)
+{
+	ipc_callid_t callid;
+	ipc_call_t call;
+	int retval;
+
+	ipc_answer_fast(iid, EOK, 0, 0); /* Accept connection */
+
+	while (1) {
+		callid = async_get_call(&call);
+
+ 		switch (IPC_GET_METHOD(call)) {
+		case IPC_M_PHONE_HUNGUP:
+				/* TODO: if its a device connection, remove it from table */
+			return; /* Exit thread */
+
+		case DEVMAP_REGISTER:
+			/* TODO: */
+		case DEVMAP_UNREGISTER:
+			/* TODO: */
+		case DEVMAP_CONNECT_TO_DEVICE:
+			/* TODO: */
+			retval = 0;
+			break;
+		default:
+			retval = ENOENT;
+		}
+		ipc_answer_fast(callid, retval, 0, 0);
+	}
+ 		
+}
+
+
+int main(int argc, char *argv[])
+{
+
+	ipcarg_t phonead;
+
+	printf("DevMap: HelenOS device mapper.\n");
+
+	if (devmap_init() != 0) {
+		printf("Error while initializing DevMap service.");
+		return -1;
+	}
+
+		/* Set a handler of incomming connections */
+	async_set_client_connection(devmap_client_connection);
+
+		/* Register device mapper at naming service */
+	if (ipc_connect_to_me(PHONE_NS, SERVICE_DEVMAP, 0, &phonead) != 0) 
+		return -1;
+	
+	async_manager();
+	/* Never reached */
+	return 0;
+}
+
+/** 
+ * @}
+ */
+
Index: uspace/srv/devmap/devmap.h
===================================================================
--- uspace/srv/devmap/devmap.h	(revision 13125d316cadbe5c47c47ef30447ada47c3c3615)
+++ uspace/srv/devmap/devmap.h	(revision 13125d316cadbe5c47c47ef30447ada47c3c3615)
@@ -0,0 +1,43 @@
+/*
+ * Copyright (c) 2007 Josef Cejka
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup devmap
+ * @{
+ */ 
+
+#ifndef DEVMAP_DEVMAP_H_
+#define DEVMAP_DEVMAP_H_
+
+typedef enum {
+	DEVMAP_REGISTER = FIRST_USER_METHOD,
+	DEVMAP_UNREGISTER,
+	DEVMAP_CONNECT_TO_DEVICE
+} devmap_request_t;
+
+#endif
+