Index: boot/arch/sparc64/Makefile.inc
===================================================================
--- boot/arch/sparc64/Makefile.inc	(revision 63660a336967f7913b801317917bd93b4fb20796)
+++ boot/arch/sparc64/Makefile.inc	(revision 41408d9416b973ae77a095adf3dc309772bd1c56)
@@ -38,17 +38,4 @@
 EXTRA_CFLAGS = -mcpu=ultrasparc -m64 -mno-fpu -mcmodel=medlow
 
-ifeq ($(PROCESSOR), sun4v)
-RD_DRVS_ESSENTIAL += \
-	platform/sun4v \
-	char/sun4v-con
-else
-RD_DRVS_ESSENTIAL += \
-	platform/sun4u \
-	bus/pci/pciintel \
-	bus/isa \
-	intctl/obio \
-	char/ns8250
-endif
-
 SOURCES = \
 	arch/$(BARCH)/src/asm.S \
Index: rnel/arch/sparc64/Makefile.inc
===================================================================
--- kernel/arch/sparc64/Makefile.inc	(revision 63660a336967f7913b801317917bd93b4fb20796)
+++ 	(revision )
@@ -1,113 +1,0 @@
-#
-# Copyright (c) 2005 Martin Decky
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-#
-# - Redistributions of source code must retain the above copyright
-#   notice, this list of conditions and the following disclaimer.
-# - Redistributions in binary form must reproduce the above copyright
-#   notice, this list of conditions and the following disclaimer in the
-#   documentation and/or other materials provided with the distribution.
-# - The name of the author may not be used to endorse or promote products
-#   derived from this software without specific prior written permission.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
-# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
-# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
-# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
-# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
-# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
-# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
-# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
-# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
-# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-#
-
-
-COMMON_CFLAGS += -m64 -mcpu=ultrasparc -mcmodel=medlow -mno-fpu
-
-LDFLAGS += -Wl,-no-check-sections
-
-BITS = 64
-ENDIANESS = BE
-
-ifeq ($(PROCESSOR),us)
-	DEFS += -DUS
-	DEFS += -DSUN4U
-	USARCH = sun4u
-endif
-
-ifeq ($(PROCESSOR),us3)
-	DEFS += -DUS3
-	DEFS += -DSUN4U
-	USARCH = sun4u
-endif
-
-ifeq ($(PROCESSOR),sun4v)
-	DEFS += -DSUN4V
-	USARCH = sun4v
-#MH
-	DEFS += -DUS
-endif
-
-ARCH_SOURCES = \
-	arch/$(KARCH)/src/sparc64.c \
-	arch/$(KARCH)/src/cpu/$(USARCH)/cpu.c \
-	arch/$(KARCH)/src/debug/stacktrace.c \
-	arch/$(KARCH)/src/debug/stacktrace_asm.S \
-	arch/$(KARCH)/src/asm.S \
-	arch/$(KARCH)/src/$(USARCH)/asm.S \
-	arch/$(KARCH)/src/console.c \
-	arch/$(KARCH)/src/context.S \
-	arch/$(KARCH)/src/fpu_context.c \
-	arch/$(KARCH)/src/dummy.S \
-	arch/$(KARCH)/src/mm/$(USARCH)/km.c \
-	arch/$(KARCH)/src/mm/$(USARCH)/as.c \
-	arch/$(KARCH)/src/mm/$(USARCH)/frame.c \
-	arch/$(KARCH)/src/mm/page.c \
-	arch/$(KARCH)/src/mm/$(USARCH)/tlb.c \
-	arch/$(KARCH)/src/$(USARCH)/sparc64.c \
-	arch/$(KARCH)/src/$(USARCH)/start.S \
-	arch/$(KARCH)/src/proc/$(USARCH)/scheduler.c \
-	arch/$(KARCH)/src/proc/thread.c \
-	arch/$(KARCH)/src/smc.c \
-	arch/$(KARCH)/src/trap/$(USARCH)/mmu.S \
-	arch/$(KARCH)/src/trap/$(USARCH)/trap_table.S \
-	arch/$(KARCH)/src/trap/trap.c \
-	arch/$(KARCH)/src/trap/exception.c \
-	arch/$(KARCH)/src/trap/interrupt.c \
-	arch/$(KARCH)/src/drivers/tick.c \
-	arch/$(KARCH)/src/drivers/kbd.c \
-	arch/$(KARCH)/src/drivers/tty.c \
-	arch/$(KARCH)/src/drivers/pci.c \
-	arch/$(KARCH)/src/trap/$(USARCH)/interrupt.c
-
-ifeq ($(USARCH),sun4v)
-	ARCH_SOURCES += \
-		arch/$(KARCH)/src/drivers/niagara.c \
-		arch/$(KARCH)/src/sun4v/md.c
-endif
-
-ifeq ($(CONFIG_FB),y)
-	ARCH_SOURCES += \
-		arch/$(KARCH)/src/drivers/scr.c
-endif
-
-ifeq ($(CONFIG_SMP),y)
-	ARCH_SOURCES += \
-		arch/$(KARCH)/src/smp/$(USARCH)/smp.c \
-		arch/$(KARCH)/src/smp/$(USARCH)/ipi.c
-endif
-
-ifeq ($(CONFIG_TSB),y)
-	ARCH_SOURCES += \
-		arch/$(KARCH)/src/mm/$(USARCH)/tsb.c
-endif
-
-ARCH_AUTOCHECK_HEADERS = \
-	arch/$(KARCH)/include/arch/istate_struct.h \
-	arch/$(KARCH)/include/arch/context_struct.h
-
Index: kernel/arch/sparc64/meson.build
===================================================================
--- kernel/arch/sparc64/meson.build	(revision 41408d9416b973ae77a095adf3dc309772bd1c56)
+++ kernel/arch/sparc64/meson.build	(revision 41408d9416b973ae77a095adf3dc309772bd1c56)
@@ -0,0 +1,104 @@
+#
+# Copyright (c) 2005 Martin Decky
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+if PROCESSOR == 'us' or PROCESSOR == 'us3'
+	USARCH = 'sun4u'
+elif PROCESSOR == 'sun4v'
+	USARCH = 'sun4v'
+else
+	error('Unknown PROCESSOR: ' + PROCESSOR)
+endif
+
+arch_src += files(
+	'src/sparc64.c',
+	'src/cpu' / USARCH / 'cpu.c',
+	'src/debug/stacktrace.c',
+	'src/debug/stacktrace_asm.S',
+	'src/asm.S',
+	'src' / USARCH / 'asm.S',
+	'src/console.c',
+	'src/context.S',
+	'src/fpu_context.c',
+	'src/dummy.S',
+	'src/mm' / USARCH / 'km.c',
+	'src/mm' / USARCH / 'as.c',
+	'src/mm' / USARCH / 'frame.c',
+	'src/mm/page.c',
+	'src/mm' / USARCH / 'tlb.c',
+	'src' / USARCH / 'sparc64.c',
+	'src' / USARCH / 'start.S',
+	'src/proc' / USARCH / 'scheduler.c',
+	'src/proc/thread.c',
+	'src/smc.c',
+	'src/trap' / USARCH / 'mmu.S',
+	'src/trap' / USARCH / 'trap_table.S',
+	'src/trap/trap.c',
+	'src/trap/exception.c',
+	'src/trap/interrupt.c',
+	'src/drivers/tick.c',
+	'src/drivers/kbd.c',
+	'src/drivers/tty.c',
+	'src/drivers/pci.c',
+	'src/trap' / USARCH / 'interrupt.c',
+)
+
+if USARCH == 'sun4v'
+	arch_src += files(
+		'src/drivers/niagara.c',
+		'src/sun4v/md.c',
+	)
+endif
+
+if CONFIG_FB
+	arch_src += files(
+		'src/drivers/scr.c',
+	)
+endif
+
+if CONFIG_SMP
+	arch_src += files(
+		'src/smp' / USARCH / 'smp.c',
+		'src/smp' / USARCH / 'ipi.c',
+	)
+endif
+
+if CONFIG_TSB
+	arch_src += files(
+		'src/mm' / USARCH / 'tsb.c',
+	)
+endif
+
+
+_check_headers = [
+	'include/arch/istate_struct.h',
+	'include/arch/context_struct.h',
+]
+
+foreach h : _check_headers
+	arch_src += [ autocheck.process(h) ]
+endforeach
Index: kernel/genarch/meson.build
===================================================================
--- kernel/genarch/meson.build	(revision 63660a336967f7913b801317917bd93b4fb20796)
+++ kernel/genarch/meson.build	(revision 41408d9416b973ae77a095adf3dc309772bd1c56)
@@ -142,5 +142,5 @@
 
 if CONFIG_OFW_PCI
-	_src += [ 'ofw/ebus.c', 'ofw/pci.c ', 'ofw/sbus.c', 'ofw/upa.c' ]
+	_src += [ 'ofw/ebus.c', 'ofw/pci.c', 'ofw/sbus.c', 'ofw/upa.c' ]
 endif
 
Index: kernel/meson.build
===================================================================
--- kernel/meson.build	(revision 63660a336967f7913b801317917bd93b4fb20796)
+++ kernel/meson.build	(revision 41408d9416b973ae77a095adf3dc309772bd1c56)
@@ -43,4 +43,5 @@
 	command: [
 		cc.cmd_array(),
+		arch_kernel_c_args,
 		kernel_defs,
 		'-I' + meson.current_source_dir() / 'arch' / h_arch / 'include',
Index: meson.build
===================================================================
--- meson.build	(revision 63660a336967f7913b801317917bd93b4fb20796)
+++ meson.build	(revision 41408d9416b973ae77a095adf3dc309772bd1c56)
@@ -2,5 +2,4 @@
 # TODO: jobfile
 # TODO: lto
-# TODO: -D__$(ENDIANESS)__ in cross
 # TODO: CONFIG_BUILD_SHARED_LIBS
 # TODO: fix clang build
@@ -67,4 +66,5 @@
 	'OPTIMIZATION',
 	'PROCESSOR',
+	'QUADFLOAT',
 	'RDFMT',
 
@@ -106,4 +106,5 @@
 	'CONFIG_TEST',
 	'CONFIG_TRACE',
+	'CONFIG_TSB',
 	'CONFIG_UDEBUG',
 	'CONFIG_VIA_CUDA',
Index: meson/arch/sparc64/meson.build
===================================================================
--- meson/arch/sparc64/meson.build	(revision 41408d9416b973ae77a095adf3dc309772bd1c56)
+++ meson/arch/sparc64/meson.build	(revision 41408d9416b973ae77a095adf3dc309772bd1c56)
@@ -0,0 +1,62 @@
+arch_uspace_c_args = [ '-D__BE__', '-m64', '-mcmodel=medlow', '-mhard-float', '-m' + QUADFLOAT + '-quad-float' ]
+
+if PROCESSOR == 'sun4v'
+	arch_uspace_c_args += [ '-mcpu=niagara', '-mno-vis' ]
+else
+	arch_uspace_c_args += [ '-mcpu=ultrasparc' ]
+endif
+
+if PROCESSOR == 'us' or PROCESSOR == 'us3'
+	arch_uspace_c_args += [ '-DSUN4U' ]
+elif PROCESSOR == 'sun4v'
+	arch_uspace_c_args += [ '-DSUN4V' ]
+else
+	error('Unknown PROCESSOR: ' + PROCESSOR)
+endif
+
+
+arch_kernel_c_args = [ '-D__BE__', '-m64', '-mcmodel=medlow', '-mcpu=ultrasparc', '-mno-fpu' ]
+
+if PROCESSOR == 'us'
+	arch_kernel_c_args += [
+		'-DUS',
+		'-DSUN4U',
+	]
+elif PROCESSOR == 'us3'
+	arch_kernel_c_args += [
+		'-DUS3',
+		'-DSUN4U',
+	]
+elif PROCESSOR == 'sun4v'
+	arch_kernel_c_args += [
+		'-DSUN4V',
+		#MH
+		'-DUS',
+	]
+endif
+
+
+arch_kernel_link_args = [ '-nostdlib', '-Wl,-no-check-sections' ]
+arch_uspace_link_args = [ '-nostdlib', '-lgcc' ]
+
+if PROCESSOR == 'sun4v'
+	arch_uspace_link_args += [ '-Wl,-z,max-page-size=0x2000' ]
+else
+	arch_uspace_link_args += [ '-Wl,-z,max-page-size=0x4000' ]
+endif
+
+
+if PROCESSOR == 'sun4v'
+	rd_essential += [
+		'drv/platform/sun4v',
+		'drv/char/sun4v-con',
+	]
+else
+	rd_essential += [
+		'drv/platform/sun4u',
+		'drv/bus/pci/pciintel',
+		'drv/bus/isa',
+		'drv/intctl/obio',
+		'drv/char/ns8250',
+	]
+endif
Index: meson/cross/sparc64
===================================================================
--- meson/cross/sparc64	(revision 41408d9416b973ae77a095adf3dc309772bd1c56)
+++ meson/cross/sparc64	(revision 41408d9416b973ae77a095adf3dc309772bd1c56)
@@ -0,0 +1,26 @@
+# See http://mesonbuild.com/Cross-compilation.html
+
+[binaries]
+c = 'sparc64-helenos-gcc'
+cpp = 'sparc64-helenos-g++'
+ar = 'sparc64-helenos-ar'
+strip = 'sparc64-helenos-strip'
+nm = 'sparc64-helenos-nm'
+objcopy = 'sparc64-helenos-objcopy'
+objdump = 'sparc64-helenos-objdump'
+as = 'sparc64-helenos-as'
+ld = 'sparc64-helenos-ld'
+
+[properties]
+has_function_printf = true
+needs_exe_wrapper = true
+
+cc_arch = 'sparc64'
+h_arch = 'sparc64'
+bits = 64
+
+[host_machine]
+system = 'helenos'
+cpu_family = 'sparc64'
+cpu = 'sparc64'
+endian = 'big'
Index: pace/lib/c/arch/sparc64/Makefile.common
===================================================================
--- uspace/lib/c/arch/sparc64/Makefile.common	(revision 63660a336967f7913b801317917bd93b4fb20796)
+++ 	(revision )
@@ -1,54 +1,0 @@
-#
-# Copyright (c) 2006 Martin Decky
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-#
-# - Redistributions of source code must retain the above copyright
-#   notice, this list of conditions and the following disclaimer.
-# - Redistributions in binary form must reproduce the above copyright
-#   notice, this list of conditions and the following disclaimer in the
-#   documentation and/or other materials provided with the distribution.
-# - The name of the author may not be used to endorse or promote products
-#   derived from this software without specific prior written permission.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
-# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
-# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
-# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
-# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
-# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
-# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
-# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
-# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
-# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-#
-
-ifeq ($(PROCESSOR),sun4v)
-COMMON_CFLAGS += -mcpu=niagara -mno-vis
-else
-COMMON_CFLAGS += -mcpu=ultrasparc
-endif
-
-COMMON_CFLAGS += -m64 -mcmodel=medlow -mhard-float -m$(QUADFLOAT)-quad-float
-
-LDFLAGS += -Wl,-no-check-sections,--gc-sections
-
-
-
-ifeq ($(PROCESSOR),us)
-	DEFS += -DSUN4U
-endif
-
-ifeq ($(PROCESSOR),us3)
-	DEFS += -DSUN4U
-endif
-
-ifeq ($(PROCESSOR),sun4v)
-	DEFS += -DSUN4V
-	COMMON_CFLAGS += -Wl,-z,max-page-size=0x2000
-else
-	COMMON_CFLAGS += -Wl,-z,max-page-size=0x4000
-endif
Index: pace/lib/c/arch/sparc64/Makefile.inc
===================================================================
--- uspace/lib/c/arch/sparc64/Makefile.inc	(revision 63660a336967f7913b801317917bd93b4fb20796)
+++ 	(revision )
@@ -1,40 +1,0 @@
-#
-# Copyright (c) 2006 Martin Decky
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-#
-# - Redistributions of source code must retain the above copyright
-#   notice, this list of conditions and the following disclaimer.
-# - Redistributions in binary form must reproduce the above copyright
-#   notice, this list of conditions and the following disclaimer in the
-#   documentation and/or other materials provided with the distribution.
-# - The name of the author may not be used to endorse or promote products
-#   derived from this software without specific prior written permission.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
-# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
-# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
-# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
-# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
-# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
-# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
-# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
-# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
-# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-#
-
-ARCH_SOURCES = \
-	arch/$(UARCH)/src/entryjmp.S \
-	arch/$(UARCH)/src/thread_entry.S \
-	arch/$(UARCH)/src/fibril.S \
-	arch/$(UARCH)/src/tls.c \
-	arch/$(UARCH)/src/stacktrace.c \
-	arch/$(UARCH)/src/stacktrace_asm.S \
-	arch/$(UARCH)/src/rtld/dynamic.c \
-	arch/$(UARCH)/src/rtld/reloc.c
-
-ARCH_AUTOCHECK_HEADERS = \
-	arch/$(UARCH)/include/libarch/fibril_context.h
Index: uspace/lib/c/arch/sparc64/meson.build
===================================================================
--- uspace/lib/c/arch/sparc64/meson.build	(revision 41408d9416b973ae77a095adf3dc309772bd1c56)
+++ uspace/lib/c/arch/sparc64/meson.build	(revision 41408d9416b973ae77a095adf3dc309772bd1c56)
@@ -0,0 +1,42 @@
+#
+# Copyright (c) 2006 Martin Decky
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+arch_src += [ autocheck.process('include/libarch/fibril_context.h') ]
+
+arch_src += files(
+	'src/entryjmp.S',
+	'src/thread_entry.S',
+	'src/fibril.S',
+	'src/tls.c',
+	'src/stacktrace.c',
+	'src/stacktrace_asm.S',
+	'src/rtld/dynamic.c',
+	'src/rtld/reloc.c',
+)
+
+arch_start_src = files('src/crt0.S')